"use strict";
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var chai = require("chai");
var rxjs_1 = require("rxjs");
require("mocha");
var expect = chai.expect;
var actions_1 = require("./actions");
describe('fx-state', function () {
    var params = { param1: 'abc', param2: '123' };
    var data = { prop1: true, prop2: 10 };
    var noParamsEffect$ = function () { return rxjs_1.of(data); };
    function withParamsEffect$(params) {
        return __asyncGenerator(this, arguments, function withParamsEffect$_1() {
            var toYield;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!params) return [3 /*break*/, 4];
                        return [4 /*yield*/, __await(noParamsEffect$().toPromise())];
                    case 1:
                        toYield = _a.sent();
                        return [4 /*yield*/, __await(toYield)];
                    case 2: return [4 /*yield*/, _a.sent()];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 7];
                    case 4: return [4 /*yield*/, __await(null)];
                    case 5: return [4 /*yield*/, _a.sent()];
                    case 6:
                        _a.sent();
                        _a.label = 7;
                    case 7: return [2 /*return*/];
                }
            });
        });
    }
    var openState = {
        status: 'active',
        params: params,
        error: null,
        data: data,
    };
    var fxSlice = function (fxState, id) {
        var _a;
        return ({
            fx: (_a = {}, _a[id] = fxState, _a),
        });
    };
    var withParamsActions;
    var withSubtypeActions;
    beforeEach(function () {
        withParamsActions = actions_1.fxActions(withParamsEffect$);
        withSubtypeActions = actions_1.fxActions({
            effect: withParamsEffect$,
            effectName: 'TEST',
        });
    });
    describe('fxActions', function () {
        it('should return a new set of action creators for a unique ID', function () {
            var nextAction = withParamsActions.data(data);
            expect(nextAction).to.have.property('type', "fx/withParamsEffect$/data");
            expect(nextAction).to.deep.property('payload', [data]);
            expect(nextAction.fx).to.have.property('id');
        });
        it('should return a new set of action creators for a given subtype', function () {
            var nextAction = withSubtypeActions.data(data);
            expect(nextAction).to.have.property('type', "fx/TEST/data");
            expect(nextAction).to.deep.property('payload', [data]);
            expect(nextAction.fx).to.have.property('id');
        });
        describe('actions#selector', function () {
            it('should return the owned state of a set of actions', function () {
                var state = fxSlice(openState, withParamsActions.id);
                var selector = withParamsActions.selector;
                expect(selector(state)).to.have.property('status', 'active');
                expect(selector(state)).to.have.property('data', data);
            });
        });
        describe('actions#<action>#match', function () {
            it('should return a function that returns true iff it is given an action created by this exact action creator', function () {
                expect(withParamsActions.data.match(withParamsActions.data(''))).to.be.true;
                expect(withParamsActions.data.match(withParamsActions.call(''))).to.be.false;
                expect(withParamsActions.data.match(withSubtypeActions.data(''))).to.be.false;
                // giving it a name so that fxActions doesn't complain
                function effect() {
                    return Promise.resolve(10);
                }
                expect(withParamsActions.data.match(actions_1.fxActions(effect).data(10))).to.be.false;
                expect(withParamsActions.data.match({ type: 'ACTION' })).to.be.false;
            });
        });
    });
});
//# sourceMappingURL=actions.spec.js.map