"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var actions_1 = require("./actions");
var cache_1 = require("./cache");
exports.fxEpic = function (action$) {
    return action$.pipe(operators_1.filter(actions_1.isCallFxAction), operators_1.mergeMap(function (action) {
        var uuidEntry = cache_1.get(action.fx.id);
        if (uuidEntry) {
            var _a = uuidEntry.actions, matchCall_1 = _a.call.match, data_1 = _a.data, error_1 = _a.error, complete_1 = _a.complete, matchDestroy_1 = _a.destroy.match, effect_1 = uuidEntry.effect;
            return new rxjs_1.Observable(function (subscriber) {
                try {
                    var subscription_1 = effect_1(action.payload).subscribe(function (nextData) { return subscriber.next(data_1(nextData)); }, function (err) { return subscriber.next(error_1(err)); }, function () { return subscriber.next(complete_1()); });
                    action$
                        .pipe(operators_1.filter(function (action) { return matchCall_1(action) || matchDestroy_1(action); }), operators_1.first())
                        .subscribe(function () { return subscription_1.unsubscribe(); });
                }
                catch (err) {
                    subscriber.next(error_1(err));
                }
            });
        }
        else {
            return rxjs_1.empty();
        }
    }));
};
exports.fxMiddleware = function (store) {
    var action$ = new rxjs_1.Subject();
    exports.fxEpic(action$).subscribe(store.dispatch);
    return function (next) { return function (action) {
        var result = next(action);
        action$.next(action);
        return result;
    }; };
};
//# sourceMappingURL=middleware.js.map