"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var FxState_1 = require("./FxState");
var actions_1 = require("./actions");
var chainReducers_1 = require("./chainReducers");
var cache_1 = require("./cache");
var callReducer = function (state, action) {
    if (state === void 0) { state = FxState_1.initialFxState; }
    return actions_1.isFxAction(action) && action.fx.fxType === 'call'
        ? __assign({}, state, { status: 'active', params: action.payload, data: null, error: null }) : state;
};
var dataReducer = function (state, action) {
    if (state === void 0) { state = FxState_1.initialFxState; }
    return actions_1.isFxAction(action) && action.fx.fxType === 'data'
        ? __assign({}, state, { data: action.payload[0], error: null }) : state;
};
var errorReducer = function (state, action) {
    if (state === void 0) { state = FxState_1.initialFxState; }
    return actions_1.isFxAction(action) && action.fx.fxType === 'error'
        ? __assign({}, state, { status: 'error', error: action.payload[0] }) : state;
};
var completeReducer = function (state, action) {
    if (state === void 0) { state = FxState_1.initialFxState; }
    return actions_1.isFxAction(action) && action.fx.fxType === 'complete'
        ? __assign({}, state, { status: 'completed', error: null }) : state;
};
exports.fxStateReducer = chainReducers_1.default(callReducer, dataReducer, errorReducer, completeReducer);
exports.fxSliceReducer = function (state, action) {
    if (state === void 0) { state = { fx: {} }; }
    if (actions_1.isFxAction(action)) {
        var id = action.fx.id;
        var nextState = __assign({}, state, { fx: __assign({}, state.fx) });
        if (action.fx.fxType === 'destroy') {
            delete nextState.fx[id];
            cache_1.remove(id);
        }
        else {
            nextState.fx[id] = exports.fxStateReducer(nextState.fx[id], action);
        }
        return nextState;
    }
    return state;
};
exports.fxReducer = exports.fxSliceReducer;
//# sourceMappingURL=reducer.js.map